#include "witch.h"

#include "../constants.h"

witch::witch(RNG *rng, const feature enabled_features, const position &pos,
             const int gen_room_num):
        enemy_base{rng, enabled_features, rwitch, pos, gen_room_num, "Z"} {}

const char *witch::get_race_name() const {
        return "Witch";
}

long_result witch::attack(character *ch) {
        auto res = ch->get_hit(this, ATK, base_hit_rate);

        if (res.res == hit && rng->trial(POTION_RATE)) {
                res.msg += "W's potion spilled onto PC. ";
                potion_type type =
                        static_cast<potion_type>(rng->rand_under(
                                        (enabled_features & FEATURE_EXTRA_STUFF) ?
                                        POTION_TYPE_CNT :
                                        DEFAULT_POTION_TYPE_CNT));
                ch->apply_effect(new_potion(type, {0, 0}));
        }

        return res;
}
